diff --git a/python/mock-1.0.0/tests/testmagicmethods.py b/python/mock-1.0.0/tests/testmagicmethods.py
index ef0f16d826..faf24a51c1 100644
--- a/python/mock-1.0.0/tests/testmagicmethods.py
+++ b/python/mock-1.0.0/tests/testmagicmethods.py
@@ -5,15 +5,15 @@
 from tests.support import unittest2, inPy3k
 
 try:
-    unicode
+    str
 except NameError:
     # Python 3
-    unicode = str
+    str = str
     long = int
 
 import inspect
 import sys
-from mock import Mock, MagicMock, _magics
+from unittest.mock import Mock, MagicMock, _magics
 
 
 
@@ -83,10 +83,10 @@ class TestMockingMagicMethods(unittest2.TestCase):
     @unittest2.skipIf(inPy3k, "no unicode in Python 3")
     def test_unicode(self):
         mock = Mock()
-        self.assertEqual(unicode(mock), unicode(str(mock)))
+        self.assertEqual(str(mock), str(str(mock)))
 
-        mock.__unicode__ = lambda s: unicode('foo')
-        self.assertEqual(unicode(mock), unicode('foo'))
+        mock.__unicode__ = lambda s: str('foo')
+        self.assertEqual(str(mock), str('foo'))
 
 
     def test_dict_methods(self):
@@ -315,14 +315,14 @@ class TestMockingMagicMethods(unittest2.TestCase):
         self.assertEqual(int(mock), 1)
         self.assertEqual(complex(mock), 1j)
         self.assertEqual(float(mock), 1.0)
-        self.assertEqual(long(mock), long(1))
+        self.assertEqual(int(mock), int(1))
         self.assertNotIn(object(), mock)
         self.assertEqual(len(mock), 0)
         self.assertEqual(list(mock), [])
         self.assertEqual(hash(mock), object.__hash__(mock))
         self.assertEqual(str(mock), object.__str__(mock))
-        self.assertEqual(unicode(mock), object.__str__(mock))
-        self.assertIsInstance(unicode(mock), unicode)
+        self.assertEqual(str(mock), object.__str__(mock))
+        self.assertIsInstance(str(mock), str)
         self.assertTrue(bool(mock))
         if not inPy3k:
             self.assertEqual(oct(mock), '1')
@@ -346,7 +346,7 @@ class TestMockingMagicMethods(unittest2.TestCase):
 
 
     def test_magic_methods_and_spec(self):
-        class Iterable(object):
+        class Iterable:
             def __iter__(self):
                 pass
 
@@ -356,7 +356,7 @@ class TestMockingMagicMethods(unittest2.TestCase):
         mock.__iter__ = Mock(return_value=iter([]))
         self.assertEqual(list(mock), [])
 
-        class NonIterable(object):
+        class NonIterable:
             pass
         mock = Mock(spec=NonIterable)
         self.assertRaises(AttributeError, lambda: mock.__iter__)
@@ -371,7 +371,7 @@ class TestMockingMagicMethods(unittest2.TestCase):
 
 
     def test_magic_methods_and_spec_set(self):
-        class Iterable(object):
+        class Iterable:
             def __iter__(self):
                 pass
 
@@ -381,7 +381,7 @@ class TestMockingMagicMethods(unittest2.TestCase):
         mock.__iter__ = Mock(return_value=iter([]))
         self.assertEqual(list(mock), [])
 
-        class NonIterable(object):
+        class NonIterable:
             pass
         mock = Mock(spec_set=NonIterable)
         self.assertRaises(AttributeError, lambda: mock.__iter__)
@@ -399,7 +399,7 @@ class TestMockingMagicMethods(unittest2.TestCase):
         mock = MagicMock()
         def set_setattr():
             mock.__setattr__ = lambda self, name: None
-        self.assertRaisesRegexp(AttributeError,
+        self.assertRaisesRegex(AttributeError,
             "Attempting to set unsupported magic method '__setattr__'.",
             set_setattr
         )
diff --git a/python/mock-1.0.0/tests/testmock.py b/python/mock-1.0.0/tests/testmock.py
index f3ceea9955..3f6cb2da00 100644
--- a/python/mock-1.0.0/tests/testmock.py
+++ b/python/mock-1.0.0/tests/testmock.py
@@ -10,8 +10,8 @@ import copy
 import pickle
 import sys
 
-import mock
-from mock import (
+from unittest import mock
+from unittest.mock import (
     call, DEFAULT, patch, sentinel,
     MagicMock, Mock, NonCallableMock,
     NonCallableMagicMock, _CallList,
@@ -20,12 +20,12 @@ from mock import (
 
 
 try:
-    unicode
+    str
 except NameError:
-    unicode = str
+    str = str
 
 
-class Iter(object):
+class Iter:
     def __init__(self):
         self.thing = iter(['this', 'is', 'an', 'iter'])
 
@@ -42,7 +42,7 @@ class Subclass(MagicMock):
     pass
 
 
-class Thing(object):
+class Thing:
     attribute = 6
     foo = 'bar'
 
@@ -87,7 +87,7 @@ class MockTest(unittest2.TestCase):
 
     def test_unicode_not_broken(self):
         # This used to raise an exception with Python 2.5 and Mock 0.4
-        unicode(Mock())
+        str(Mock())
 
 
     def test_return_value_in_constructor(self):
@@ -113,7 +113,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_repr_with_spec(self):
-        class X(object):
+        class X:
             pass
 
         mock = Mock(spec=X)
@@ -396,7 +396,7 @@ class MockTest(unittest2.TestCase):
 
                 # this should be allowed
                 mock.something
-                self.assertRaisesRegexp(
+                self.assertRaisesRegex(
                     AttributeError,
                     "Mock object has no attribute 'something_else'",
                     getattr, mock, 'something_else'
@@ -404,7 +404,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_from_spec(self):
-        class Something(object):
+        class Something:
             x = 3
             __something__ = None
             def y(self):
@@ -415,12 +415,12 @@ class MockTest(unittest2.TestCase):
             mock.x
             mock.y
             mock.__something__
-            self.assertRaisesRegexp(
+            self.assertRaisesRegex(
                 AttributeError,
                 "Mock object has no attribute 'z'",
                 getattr, mock, 'z'
             )
-            self.assertRaisesRegexp(
+            self.assertRaisesRegex(
                 AttributeError,
                 "Mock object has no attribute '__foobar__'",
                 getattr, mock, '__foobar__'
@@ -453,7 +453,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_wraps_attributes(self):
-        class Real(object):
+        class Real:
             attribute = Mock()
 
         real = Real()
@@ -486,7 +486,7 @@ class MockTest(unittest2.TestCase):
 
     def test_assert_called_with_message(self):
         mock = Mock()
-        self.assertRaisesRegexp(AssertionError, 'Not called',
+        self.assertRaisesRegex(AssertionError, 'Not called',
                                 mock.assert_called_with)
 
 
@@ -509,7 +509,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_spec_class(self):
-        class X(object):
+        class X:
             pass
 
         mock = Mock(spec=X)
@@ -529,7 +529,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_setting_attribute_with_spec_set(self):
-        class X(object):
+        class X:
             y = 3
 
         mock = Mock(spec=X)
@@ -547,7 +547,7 @@ class MockTest(unittest2.TestCase):
         current = sys.getrecursionlimit()
         self.addCleanup(sys.setrecursionlimit, current)
 
-        # can't use sys.maxint as this doesn't exist in Python 3
+        # can't use sys.maxsize as this doesn't exist in Python 3
         sys.setrecursionlimit(int(10e8))
         # this segfaults without the fix in place
         copy.copy(Mock())
@@ -626,7 +626,7 @@ class MockTest(unittest2.TestCase):
     def test_dir(self):
         mock = Mock()
         attrs = set(dir(mock))
-        type_attrs = set([m for m in dir(Mock) if not m.startswith('_')])
+        type_attrs = {m for m in dir(Mock) if not m.startswith('_')}
 
         # all public attributes from the type are included
         self.assertEqual(set(), type_attrs - attrs)
@@ -705,7 +705,7 @@ class MockTest(unittest2.TestCase):
             instance = sys.exc_info()[1]
             self.assertIsInstance(instance, exception)
         else:
-            self.fail('Exception %r not raised' % (exception,))
+            self.fail('Exception {!r} not raised'.format(exception))
 
         msg = str(instance)
         self.assertEqual(msg, message)
@@ -926,7 +926,7 @@ class MockTest(unittest2.TestCase):
         self.assertEqual([mock(), mock(), mock()], ['g', 'h', 'i'])
         self.assertRaises(StopIteration, mock)
 
-        class Foo(object):
+        class Foo:
             pass
         mock = MagicMock(side_effect=Foo)
         self.assertIsInstance(mock(), Foo)
@@ -1099,11 +1099,11 @@ class MockTest(unittest2.TestCase):
 
 
     def test_mock_add_spec(self):
-        class _One(object):
+        class _One:
             one = 1
-        class _Two(object):
+        class _Two:
             two = 2
-        class Anything(object):
+        class Anything:
             one = two = three = 'four'
 
         klasses = [
@@ -1202,7 +1202,7 @@ class MockTest(unittest2.TestCase):
 
 
     def test_manager_mock(self):
-        class Foo(object):
+        class Foo:
             one = 'one'
             two = 'two'
         manager = Mock()
diff --git a/python/mock-1.0.0/tests/testpatch.py b/python/mock-1.0.0/tests/testpatch.py
index 1ebe671065..37b395374c 100644
--- a/python/mock-1.0.0/tests/testpatch.py
+++ b/python/mock-1.0.0/tests/testpatch.py
@@ -8,7 +8,7 @@ import sys
 from tests import support
 from tests.support import unittest2, inPy3k, SomeClass, is_instance, callable
 
-from mock import (
+from unittest.mock import (
     NonCallableMock, CallableMixin, patch, sentinel,
     MagicMock, Mock, NonCallableMagicMock, patch, _patch,
     DEFAULT, call, _get_target
@@ -17,14 +17,14 @@ from mock import (
 builtin_string = '__builtin__'
 if inPy3k:
     builtin_string = 'builtins'
-    unicode = str
+    str = str
 
 PTModule = sys.modules[__name__]
 MODNAME = '%s.PTModule' % __name__
 
 
 def _get_proxy(obj, get_only=True):
-    class Proxy(object):
+    class Proxy:
         def __getattr__(self, name):
             return getattr(obj, name)
     if not get_only:
@@ -42,7 +42,7 @@ something  = sentinel.Something
 something_else  = sentinel.SomethingElse
 
 
-class Foo(object):
+class Foo:
     def __init__(self, a):
         pass
     def f(self, a):
@@ -51,7 +51,7 @@ class Foo(object):
         pass
     foo = 'bar'
 
-    class Bar(object):
+    class Bar:
         def a(self):
             pass
 
@@ -62,7 +62,7 @@ def function(a, b=Foo):
     pass
 
 
-class Container(object):
+class Container:
     def __init__(self):
         self.values = {}
 
@@ -93,7 +93,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_single_patchobject(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
 
         @patch.object(Something, 'attribute', sentinel.Patched)
@@ -106,7 +106,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patchobject_with_none(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
 
         @patch.object(Something, 'attribute', None)
@@ -119,7 +119,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_multiple_patchobject(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
             next_attribute = sentinel.Original2
 
@@ -188,7 +188,7 @@ class PatchTest(unittest2.TestCase):
         mock.return_value = sentinel.Handle
         @patch('%s.open' % builtin_string, mock)
         def test():
-            self.assertEqual(open('filename', 'r'), sentinel.Handle,
+            self.assertEqual(open('filename'), sentinel.Handle,
                              "open not patched")
         test()
         test()
@@ -209,7 +209,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patchobject_with_default_mock(self):
-        class Test(object):
+        class Test:
             something = sentinel.Original
             something2 = sentinel.Original2
 
@@ -391,7 +391,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patch_with_static_methods(self):
-        class Foo(object):
+        class Foo:
             @staticmethod
             def woot():
                 return sentinel.Static
@@ -415,7 +415,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patch_slots(self):
-        class Foo(object):
+        class Foo:
             __slots__ = ('Foo',)
 
         foo = Foo()
@@ -430,10 +430,10 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patchobject_class_decorator(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
 
-        class Foo(object):
+        class Foo:
             def test_method(other_self):
                 self.assertEqual(Something.attribute, sentinel.Patched,
                                  "unpatched")
@@ -452,10 +452,10 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patch_class_decorator(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
 
-        class Foo(object):
+        class Foo:
             def test_method(other_self, mock_something):
                 self.assertEqual(PTModule.something, mock_something,
                                  "unpatched")
@@ -475,7 +475,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patchobject_twice(self):
-        class Something(object):
+        class Something:
             attribute = sentinel.Original
             next_attribute = sentinel.Original2
 
@@ -648,10 +648,10 @@ class PatchTest(unittest2.TestCase):
     def test_patch_descriptor(self):
         # would be some effort to fix this - we could special case the
         # builtin descriptors: classmethod, property, staticmethod
-        class Nothing(object):
+        class Nothing:
             foo = None
 
-        class Something(object):
+        class Something:
             foo = {}
 
             @patch.object(Nothing, 'foo', 2)
@@ -773,7 +773,7 @@ class PatchTest(unittest2.TestCase):
         d = {'spam': 'eggs'}
         original = d.copy()
 
-        class Test(object):
+        class Test:
             def test_first(self):
                 this.assertEqual(d, {'foo': 'bar'})
             def test_second(self):
@@ -800,7 +800,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_get_only_proxy(self):
-        class Something(object):
+        class Something:
             foo = 'foo'
         class SomethingElse:
             foo = 'foo'
@@ -818,7 +818,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_get_set_delete_proxy(self):
-        class Something(object):
+        class Something:
             foo = 'foo'
         class SomethingElse:
             foo = 'foo'
@@ -877,7 +877,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_autospec(self):
-        class Boo(object):
+        class Boo:
             def __init__(self, a):
                 pass
             def f(self, a):
@@ -886,7 +886,7 @@ class PatchTest(unittest2.TestCase):
                 pass
             foo = 'bar'
 
-            class Bar(object):
+            class Bar:
                 def a(self):
                     pass
 
@@ -1059,7 +1059,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_new_callable_keyword_arguments(self):
-        class Bar(object):
+        class Bar:
             kwargs = None
             def __init__(self, **kwargs):
                 Bar.kwargs = kwargs
@@ -1074,7 +1074,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_new_callable_spec(self):
-        class Bar(object):
+        class Bar:
             kwargs = None
             def __init__(self, **kwargs):
                 Bar.kwargs = kwargs
@@ -1149,7 +1149,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_new_callable_inherit_non_mock(self):
-        class NotAMock(object):
+        class NotAMock:
             def __init__(self, spec):
                 self.spec = spec
 
@@ -1167,7 +1167,7 @@ class PatchTest(unittest2.TestCase):
     def test_new_callable_class_decorating(self):
         test = self
         original = Foo
-        class SomeTest(object):
+        class SomeTest:
 
             def _test(self, mock_foo):
                 test.assertIsNot(Foo, original)
@@ -1316,7 +1316,7 @@ class PatchTest(unittest2.TestCase):
         try:
             f = result['f']
             foo = result['foo']
-            self.assertEqual(set(result), set(['f', 'foo']))
+            self.assertEqual(set(result), {'f', 'foo'})
 
             self.assertIs(Foo, original_foo)
             self.assertIs(Foo.f, f)
@@ -1336,7 +1336,7 @@ class PatchTest(unittest2.TestCase):
         original_f = Foo.f
         original_g = Foo.g
 
-        class SomeTest(object):
+        class SomeTest:
 
             def _test(self, f, foo):
                 test.assertIs(Foo, original_foo)
@@ -1394,7 +1394,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patch_multiple_new_callable(self):
-        class Thing(object):
+        class Thing:
             pass
 
         patcher = patch.multiple(
@@ -1528,7 +1528,7 @@ class PatchTest(unittest2.TestCase):
 
 
     def test_patch_multiple_string_subclasses(self):
-        for base in (str, unicode):
+        for base in (str, str):
             Foo = type('Foo', (base,), {'fish': 'tasty'})
             foo = Foo()
             @patch.multiple(foo, fish='nearly gone')
@@ -1541,7 +1541,7 @@ class PatchTest(unittest2.TestCase):
 
     @patch('mock.patch.TEST_PREFIX', 'foo')
     def test_patch_test_prefix(self):
-        class Foo(object):
+        class Foo:
             thing = 'original'
 
             def foo_one(self):
@@ -1564,7 +1564,7 @@ class PatchTest(unittest2.TestCase):
 
     @patch('mock.patch.TEST_PREFIX', 'bar')
     def test_patch_dict_test_prefix(self):
-        class Foo(object):
+        class Foo:
             def bar_one(self):
                 return dict(the_dict)
             def bar_two(self):
diff --git a/python/mock-1.0.0/tests/testsentinel.py b/python/mock-1.0.0/tests/testsentinel.py
index 981171a450..cd9200a3bc 100644
--- a/python/mock-1.0.0/tests/testsentinel.py
+++ b/python/mock-1.0.0/tests/testsentinel.py
@@ -4,7 +4,7 @@
 
 from tests.support import unittest2
 
-from mock import sentinel, DEFAULT
+from unittest.mock import sentinel, DEFAULT
 
 
 class SentinelTest(unittest2.TestCase):
diff --git a/python/mozbuild/dumbmake/dumbmake.py b/python/mozbuild/dumbmake/dumbmake.py
index 5457c8b0a0..7ba2725a14 100644
--- a/python/mozbuild/dumbmake/dumbmake.py
+++ b/python/mozbuild/dumbmake/dumbmake.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 from collections import OrderedDict
 from itertools import groupby
@@ -36,7 +35,7 @@ def dependency_map(lines):
     deps = {}
 
     for i, (indent, target) in enumerate(pairs):
-        if not deps.has_key(target):
+        if target not in deps:
             deps[target] = []
 
         for j in range(i+1, len(pairs)):
@@ -68,7 +67,7 @@ def all_dependencies(*targets, **kwargs):
                     del all_targets[dependency]
                 all_targets[dependency] = True
 
-    return all_targets.keys()
+    return list(all_targets.keys())
 
 def get_components(path):
     """Take a path and return all the components of the path."""
@@ -114,7 +113,7 @@ def add_extra_dependencies(target_pairs, dependency_map):
                 make_dirs[make_dir] = True
 
     all_components = []
-    for make_dir in make_dirs.iterkeys():
+    for make_dir in make_dirs.keys():
         all_components.extend(get_components(make_dir))
 
     for i in all_dependencies(*all_components, dependency_map=dependency_map):
diff --git a/python/mozbuild/dumbmake/test/test_dumbmake.py b/python/mozbuild/dumbmake/test/test_dumbmake.py
index 1172117aaf..d157f26804 100644
--- a/python/mozbuild/dumbmake/test/test_dumbmake.py
+++ b/python/mozbuild/dumbmake/test/test_dumbmake.py
@@ -1,7 +1,6 @@
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
-from __future__ import unicode_literals
 
 import unittest
 
diff --git a/python/mozbuild/mozbuild/action/buildlist.py b/python/mozbuild/mozbuild/action/buildlist.py
index 9d601d69a9..fd129eab77 100644
--- a/python/mozbuild/mozbuild/action/buildlist.py
+++ b/python/mozbuild/mozbuild/action/buildlist.py
@@ -7,7 +7,6 @@ if the entry does not already exist.
 
 Usage: buildlist.py <filename> <entry> [<entry> ...]
 '''
-from __future__ import absolute_import, print_function
 
 import sys
 import os
@@ -26,14 +25,14 @@ def addEntriesToListFile(listFile, entries):
   try:
     if os.path.exists(listFile):
       f = open(listFile)
-      existing = set(x.strip() for x in f.readlines())
+      existing = {x.strip() for x in f.readlines()}
       f.close()
     else:
       existing = set()
     for e in entries:
       if e not in existing:
         existing.add(e)
-    with open(listFile, 'wb') as f:
+    with open(listFile, 'w') as f:
       f.write("\n".join(sorted(existing))+"\n")
   finally:
     lock = None
diff --git a/python/mozbuild/mozbuild/action/cl.py b/python/mozbuild/mozbuild/action/cl.py
index 1840d7d857..f9f9ebcbae 100644
--- a/python/mozbuild/mozbuild/action/cl.py
+++ b/python/mozbuild/mozbuild/action/cl.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import ctypes
 import os
@@ -55,7 +54,7 @@ def InvokeClWithDependencyGeneration(cmdline):
             break
 
     if target is None:
-        print >>sys.stderr, "No target set"
+        print("No target set", file=sys.stderr)
         return 1
 
     # Assume the source file is the last argument
diff --git a/python/mozbuild/mozbuild/action/dump_env.py b/python/mozbuild/mozbuild/action/dump_env.py
index 83e420d682..3376b6207e 100644
--- a/python/mozbuild/mozbuild/action/dump_env.py
+++ b/python/mozbuild/mozbuild/action/dump_env.py
@@ -5,6 +5,7 @@
 # We invoke a Python program to dump our environment in order to get
 # native paths printed on Windows so that these paths can be incorporated
 # into Python configure's environment.
+from __future__ import print_function
 import os
 import sys
 
@@ -13,4 +14,4 @@ sys.path.append(os.path.join(os.path.dirname(__file__), '..'))
 from shellutil import quote
 
 for key, value in os.environ.items():
-    print('%s=%s' % (key, quote(value)))
+    print(('{}={}'.format(key, quote(value))))
diff --git a/python/mozbuild/mozbuild/action/file_generate.py b/python/mozbuild/mozbuild/action/file_generate.py
index 3bdbc264bd..5b505cd64b 100644
--- a/python/mozbuild/mozbuild/action/file_generate.py
+++ b/python/mozbuild/mozbuild/action/file_generate.py
@@ -6,10 +6,9 @@
 # the arguments that can be used to generate the output file, call the
 # script's |main| method with appropriate arguments.
 
-from __future__ import absolute_import, print_function
 
 import argparse
-import imp
+import importlib.util
 import os
 import sys
 import traceback
@@ -47,13 +46,26 @@ def main(argv):
     # then importing modules from the script's directory would come for free.
     # Since we're invoking the script in a roundabout way, we provide this
     # bit of convenience.
-    sys.path.append(os.path.dirname(script))
-    with open(script, 'r') as fh:
-        module = imp.load_module('script', fh, script,
-                                 ('.py', 'r', imp.PY_SOURCE))
+    script_dir = os.path.dirname(script)
+    sys.path.append(script_dir)
+    # If the script lives inside a package, load it with its qualified name
+    # so that relative imports (from . import ...) resolve correctly.
+    if os.path.isfile(os.path.join(script_dir, '__init__.py')):
+        parent_dir = os.path.dirname(script_dir)
+        if parent_dir not in sys.path:
+            sys.path.insert(0, parent_dir)
+        pkg_name = os.path.basename(script_dir)
+        mod_name = '{}.{}'.format(pkg_name,
+                                  os.path.splitext(os.path.basename(script))[0])
+    else:
+        mod_name = 'script'
+    _spec = importlib.util.spec_from_file_location(mod_name, script)
+    module = importlib.util.module_from_spec(_spec)
+    sys.modules[mod_name] = module
+    _spec.loader.exec_module(module)
     method = args.method_name
     if not hasattr(module, method):
-        print('Error: script "{0}" is missing a {1} method'.format(script, method),
+        print('Error: script "{}" is missing a {} method'.format(script, method),
               file=sys.stderr)
         return 1
 
@@ -95,11 +107,11 @@ def main(argv):
         try:
             os.utime(args.output_file, None)
         except:
-            print('Error processing file "{0}"'.format(args.output_file),
+            print('Error processing file "{}"'.format(args.output_file),
                   file=sys.stderr)
             traceback.print_exc()
-    except IOError as e:
-        print('Error opening file "{0}"'.format(e.filename), file=sys.stderr)
+    except OSError as e:
+        print('Error opening file "{}"'.format(e.filename), file=sys.stderr)
         traceback.print_exc()
         return 1
     return ret
diff --git a/python/mozbuild/mozbuild/action/generate_browsersearch.py b/python/mozbuild/mozbuild/action/generate_browsersearch.py
index 231abe9be3..9fe90159b2 100644
--- a/python/mozbuild/mozbuild/action/generate_browsersearch.py
+++ b/python/mozbuild/mozbuild/action/generate_browsersearch.py
@@ -30,11 +30,6 @@ to browsersearch.json in the locale-specific raw resource directory
 e.g. raw/browsersearch.json, raw-pt-rBR/browsersearch.json.
 '''
 
-from __future__ import (
-    absolute_import,
-    print_function,
-    unicode_literals,
-)
 
 import argparse
 import codecs
@@ -58,7 +53,7 @@ def merge_properties(filename, srcdirs):
         path = mozpath.join(srcdir, filename)
         try:
             properties.update(path)
-        except IOError:
+        except OSError:
             # Ignore non-existing files
             continue
     return properties
diff --git a/python/mozbuild/mozbuild/action/generate_symbols_file.py b/python/mozbuild/mozbuild/action/generate_symbols_file.py
index 3eebf324cc..af1bb6fb3c 100644
--- a/python/mozbuild/mozbuild/action/generate_symbols_file.py
+++ b/python/mozbuild/mozbuild/action/generate_symbols_file.py
@@ -2,12 +2,11 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import argparse
 import buildconfig
 import os
-from StringIO import StringIO
+from io import StringIO
 from mozbuild.preprocessor import Preprocessor
 from mozbuild.util import DefinesAction
 
diff --git a/python/mozbuild/mozbuild/action/jar_maker.py b/python/mozbuild/mozbuild/action/jar_maker.py
index 3e3c3c83ef..6fc45cdf66 100644
--- a/python/mozbuild/mozbuild/action/jar_maker.py
+++ b/python/mozbuild/mozbuild/action/jar_maker.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import sys
 
diff --git a/python/mozbuild/mozbuild/action/make_dmg.py b/python/mozbuild/mozbuild/action/make_dmg.py
index 8d77bf3744..0612bc9d3b 100644
--- a/python/mozbuild/mozbuild/action/make_dmg.py
+++ b/python/mozbuild/mozbuild/action/make_dmg.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function
 
 from mozbuild.base import MozbuildObject
 from mozpack import dmg
diff --git a/python/mozbuild/mozbuild/action/output_searchplugins_list.py b/python/mozbuild/mozbuild/action/output_searchplugins_list.py
index c20e2c7328..9effb97665 100644
--- a/python/mozbuild/mozbuild/action/output_searchplugins_list.py
+++ b/python/mozbuild/mozbuild/action/output_searchplugins_list.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import sys
 import json
 
@@ -18,4 +19,4 @@ if locale in searchinfo["locales"]:
 else:
   engines = searchinfo["default"]["visibleDefaultEngines"]
 
-print '\n'.join(engines)
+print(('\n'.join(engines)))
diff --git a/python/mozbuild/mozbuild/action/preprocessor.py b/python/mozbuild/mozbuild/action/preprocessor.py
index e5a4d576ba..24f3ffe60f 100644
--- a/python/mozbuild/mozbuild/action/preprocessor.py
+++ b/python/mozbuild/mozbuild/action/preprocessor.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import sys
 
diff --git a/python/mozbuild/mozbuild/action/process_define_files.py b/python/mozbuild/mozbuild/action/process_define_files.py
index f6d0c1695a..fb7d32a292 100644
--- a/python/mozbuild/mozbuild/action/process_define_files.py
+++ b/python/mozbuild/mozbuild/action/process_define_files.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import argparse
 import os
@@ -39,8 +38,8 @@ def process_define_file(output, input):
         config = ConfigEnvironment.from_config_status(
             mozpath.join(topobjdir, 'js', 'src', 'config.status'))
 
-    with open(path, 'rU') as input:
-        r = re.compile('^\s*#\s*(?P<cmd>[a-z]+)(?:\s+(?P<name>\S+)(?:\s+(?P<value>\S+))?)?', re.U)
+    with open(path) as input:
+        r = re.compile(r'^\s*#\s*(?P<cmd>[a-z]+)(?:\s+(?P<name>\S+)(?:\s+(?P<value>\S+))?)?', re.U)
         for l in input:
             m = r.match(l)
             if m:
@@ -54,8 +53,8 @@ def process_define_file(output, input):
                                 '`#define ALLDEFINES` is not allowed in a '
                                 'CONFIGURE_DEFINE_FILE')
                         defines = '\n'.join(sorted(
-                            '#define %s %s' % (name, val)
-                            for name, val in config.defines.iteritems()
+                            '#define {} {}'.format(name, val)
+                            for name, val in config.defines.items()
                             if name not in config.non_global_defines))
                         l = l[:m.start('cmd') - 1] \
                             + defines + l[m.end('name'):]
diff --git a/python/mozbuild/mozbuild/action/process_install_manifest.py b/python/mozbuild/mozbuild/action/process_install_manifest.py
index a97a72cc6e..177b724772 100644
--- a/python/mozbuild/mozbuild/action/process_install_manifest.py
+++ b/python/mozbuild/mozbuild/action/process_install_manifest.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
+from __future__ import print_function
 import argparse
 import os
 import sys
@@ -102,13 +102,13 @@ def main(argv):
 
     elapsed = time.time() - start
 
-    print(COMPLETE.format(
+    print((COMPLETE.format(
         elapsed=elapsed,
         dest=args.destdir,
         existing=result.existing_files_count,
         updated=result.updated_files_count,
         rm_files=result.removed_files_count,
-        rm_dirs=result.removed_directories_count))
+        rm_dirs=result.removed_directories_count)))
 
 if __name__ == '__main__':
     main(sys.argv[1:])
